﻿using System.Linq;
using Styx.CommonBot.Frames;
using Styx.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;

namespace katzerle.Composites
{
    public class LootNPCsAction : Action
    {
        protected override RunStatus Run(object context)
        {
            WoWUnit lootableNpc = ObjectManager.GetObjectsOfType<WoWUnit>(true)
                .OrderBy(unit => unit.Distance)
                .FirstOrDefault(unit => unit.Lootable);
            if (lootableNpc != null)
            {
                LootNPC(lootableNpc);
                return RunStatus.Success;
            }
            return RunStatus.Failure;
        }

        private void LootNPC(WoWUnit lootableUnit)
        {

            if (lootableUnit.WithinInteractRange)
            {
                if (LootFrame.Instance != null && LootFrame.Instance.IsVisible)
                {
                    LootFrame.Instance.LootAll();
                }
                else
                    lootableUnit.Interact();
            }
            else
                Navigator.MoveTo(lootableUnit.Location);
        }
    }
}